﻿Type=Service
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region


'App Error: https://www.b4x.com/android/forum/threads/uncaught-exceptions.59805/#content
'Anleitung für Screenshot https://www.b4x.com/android/forum/threads/application_error-and-screenshot.63238/

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private logs As StringBuilder
	Private logcat As LogCat
	Private const emailAddress As String = "do2udx+Log_Crash@gmail.com"
	
	Dim loc As Localizator
	
	Dim varPrefixList As List
	Dim varRefPrefix_1, varRefPrefix_2, varRefPrefix_3 As List
	Dim varRefPrefix_2_a, varRefPrefix_2_b, varRefPrefix_3_a, varRefPrefix_3_b  As List
	
	Dim Liste_GMA As Map
	Dim Liste_Berge, Liste2 As List
	Dim Vers_BergListe As String

End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	
'Init für Localizator File
	loc.Initialize(File.DirAssets, "strings.db")		


'---
	varPrefixList.Initialize
	varPrefixList.AddAll (Array As String ("da","db","dc","dd","de","df","dg","dh","dj","dk", "dl", "dm", "dn", "do","dq", "dr", _
	                      "ok", "ol", "om"))

#region "GMA_Referenz"
	varRefPrefix_1.Initialize
	varRefPrefix_2.Initialize
	varRefPrefix_3.Initialize
	varRefPrefix_2_a.Initialize
	varRefPrefix_2_b.Initialize
	varRefPrefix_3_a.Initialize
	varRefPrefix_3_b.Initialize


	Dim ListeRefPrefix As List

	If File.Exists(File.DirAssets,"GMA_References.txt") = True Then
		Log("Referenzliste wird geladen")
		ListeRefPrefix  = File.readlist(File.DirAssets,"GMA_References.txt")
		For i=0 To ListeRefPrefix .Size-1
    		Dim varStr() As String = Regex.split(":",ListeRefPrefix.Get(i))	'Speicherpfad für Log
		 	If varStr.Length>1 Then
				Select Case  varStr(1)
 					Case "1":     varRefPrefix_1.add(varStr(0))
 					Case "2":     varRefPrefix_2.add(varStr(0))
 					Case "3":     varRefPrefix_3.add(varStr(0))
 					Case "2_a":   varRefPrefix_2_a.add(varStr(0))
	 				Case "2_b":   varRefPrefix_2_b.add(varStr(0))
 					Case "3_a":   varRefPrefix_3_a.add(varStr(0))
 					Case "3_b":   varRefPrefix_3_b.add(varStr(0))
				End Select
			End If
		Next
	Else
		'varRefPrefix_1.AddAll(Array As String("F","W","I","M","G"))
		'varRefPrefix_2.AddAll(Array As String("6K","9A","9H","9V","CT","CU","DA","DL","DM","EC","EI","ES","FA","FC","FK","FR","GD","GI","GM","GW", _
		'									  "HA","HB","HG","HL","IT","JA","JW","LA","LB","LX","LZ","MM","MW","OD","OE","OF","OH","OK","OL", _
		'									  "OM","ON","OV","OX","OY","OZ","PA","PB","SA","SM","SO","SP","SV","TF","TK","UT","XG","YO","YP","YU","ZS","ZT"))
		'varRefPrefix_2_a.AddAll(Array As String("E2","E5","E7","K1","K6","R1","R2","R3","R4","R5","R6","R7","R8","S5","V5","W1","W2","W3","W6","W9","Z3"))
		'varRefPrefix_2_b.AddAll(Array As String("6K","9A","9H","9V"))
		'varRefPrefix_3.AddAll(Array As String("KLA","KLF","KLS"))
		'varRefPrefix_3_a.AddAll(Array As String("AX2","AX3","AX4", "CT3", "EA1","EA2","EA3","EA4","EA5","EA6","EA7","EA8","EC1","EC2","EC3","EC4","EC6","EC7","EC8","EC9", _
		'				   						"HB0","HB9","IS0","JA5","JA6","JA8", "KH6","KP4","OM0","OE0","OF0","S50","PJ2","PJ4","PJ5","PJ6","PJ7", _ 
		'										"VA7","VE1","VE2","VE6","VE7","VE9","VK1","VK2","VK3","VK4","VK5","VK6","VK7","VK8","VK9","VP8", _
		'										"ZL1","ZL3","ZL7","ZL8","ZL9"))
		'varRefPrefix_3_b.AddAll(Array As String("K0M", "K4T","K5N","K5T","K4C","R9U","W4A","W4C","W4G","W4K","W4T","W4V","W5A","W5M","W5N","W5O","W5T","W0C","W0D","W0M","W0N","W7A","W7I","W7M","W7N","W7O","W7U","W7W","W7Y","W8M","W8O","W8V"))
	End If
#end region

#region "Setup & Listen Lesen"
	Dim PhatListen As String
	If File.Exists(File.DirInternal,"SetUp.udx") = True Then
		Dim Liste_Setup As List  = File.readlist(File.DirInternal,"SetUp.udx")
		For i=0 To Liste_Setup.Size-1
    		Dim varStr() As String = Regex.split(":",Liste_Setup.Get(i))	'Speicherpfad für Log
		 	If varStr(0)= "#Listen" Then
				If varStr(1)<>"AssetsDir" Then PhatListen=varStr(1)
			End If
		Next			
	End If

'Listen einlesen
	If File.Exists(PhatListen,"BergListe.txt") = True Then 
  		Liste_Berge = File.readlist(PhatListen ,"BergListe.txt")
		Log("Bergliste Extern")
	Else
  		Liste_Berge = File.readlist(File.DirAssets ,"BergListe.txt")
'		If FirstTime Then ToastMessageShow(Starter.loc.Localize("txt_ll_berg"),False) 	 		'False für kurze anzeigedauer, True für Lange
		Log("Bergliste Intern")
	End If
	
	Dim versList As String
	versList=Liste_Berge.Get(0)
	If versList.Contains  ("#") = True Then 
	 										Vers_BergListe = loc.Localize("txt_Bergliste") & ", Vers. " & versList.SubString(2)
											Liste_Berge.RemoveAt(0)
	Else
		 									Vers_BergListe=" "
	End If
	
	If File.Exists(PhatListen,"CallListe.txt") = True Then 
  		Liste2 = File.readlist(PhatListen ,"CallListe.txt")
	Else
  		Liste2 = File.readlist(File.DirAssets,"CallListe.txt")
'		If FirstTime Then ToastMessageShow(Starter.loc.Localize("txt_ll_call"),False) 	 		'False für kurze anzeigedauer, True für Lange
	End If

	If File.Exists(PhatListen,"gma_locator.txt") = True Then 
  		Liste_GMA = File.ReadMap(PhatListen ,"gma_locator.txt")
	Else
'  		Liste_GMA = File.ReadMap(File.DirAssets,"gma_locator.txt")
		'If FirstTime Then ToastMessageShow(Starter.loc.Localize("txt_ll_call"),False) 	 		'False für kurze anzeigedauer, True für Lange
	End If

#end Region
	
'---Crash Log
	logs.Initialize
#if RELEASE
	logcat.LogCatStart(Array As String("-v","raw","*:F","B4A:v"), "logcat")
#end if

	
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Private Sub logcat_LogCatData (Buffer() As Byte, Length As Int)
	logs.Append(BytesToString(Buffer, 0, Length, "utf8"))
	If logs.Length > 5000 Then
		logs.Remove(0, logs.Length - 4000)
	End If
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	'wait for 500ms to allow the logs to be updated.
	Dim jo As JavaObject
	Dim l As Long = 500
	jo.InitializeStatic("java.lang.Thread").RunMethod("sleep", Array(l)) 
	logcat.LogCatStop
	logs.Append(StackTrace)
	Dim email As Email
	email.To.Add(emailAddress)
	email.Subject = "Log crashed"
	email.Body = logs
	StartActivity(email.GetIntent)
	Return True
End Sub

Sub Service_Destroy

End Sub
